Unit BASICMK; Interface
Uses Crt;
Const Lcod=128; Hcod=159;
Const BasicMem=1221;
Const opset=[#0,'-','+','*','/','^'];

Type
BasLinePtr = ^BasLine;
BasLine = Record
 Number : word;
 Line : string[80];
 NextLine : BasLinePtr;
end;

SOC=Set of Char;

BASIC = Object
  TransCoef : double;
  LastVar : word;
  ss : string[31];
  Vrb : array[0..176] of Double;
  FORstack : array[1..4] of Record line : baslineptr; index : byte;
                adres : word;  stepval: double; stopval:double end;
  SUBstack:array[1..8] of Record line:BasLinePtr; index:byte end;
  fsp, ssp : word;
  firstline : baslineptr;
  CurPos : Integer;
  CurLine : BasLinePtr;
  comment, stopped,
  continue:boolean;

  Procedure Accept;
  Procedure Load;
  Procedure Size;
  Procedure RUN;
  Procedure Err1;
  Procedure ErrorMsg(i:byte);
  Procedure Incode(var s:string);
  Procedure Operator(s:string);
  Procedure SearchFor(stp:soc);

  Function Expression(s:string):double;
  Function Address(s:string):word;
  Function ProgLength:integer;

  Procedure LET(  s:string);
  Procedure MODE( s:string);
  Procedure GOSUB(s:string);
  Procedure FORTO(s:string);
  Procedure NEXT( s:string);
  Procedure BGOTO(s:string);
  Procedure BIF(  s:string);
  Procedure PRINT(s:string);
  Procedure DEFM( s:string);
  Procedure INPUT(s:string);
  Procedure VAC;
  Procedure RETURN;
  Procedure STOP;
  Procedure BEND;

  Function KEY:string;
  Function TAN(x:double):double;
  Function ASN(x:double):double;
  Function ACS(x:double):double;
  Function LOG(x:double):double;
  Function SGN(x:double):double;
  Function bSQR(x:double):double;
  Function bINT(x:double):double;
  Function bFRAC(x:double):double;
  Function Power(x,y:double):double;
  Function Divide(x,y:double):double;
  Function EQ(x,y:double):boolean;
end;

var txt,table:text;
    lex:array[lcod..hcod] of string[7];
    B:basic;

Implementation

  Procedure Basic.Accept;
  Label 1;
  var s,t:String;
      num,cod:word;
  Begin
    stopped:=false;
  Repeat
1:  Write('>');Readln(s);
    If (copy(s,1,4)='EXIT') or (copy(s,1,4)='QUIT') then Exit;
    If copy(s,1,4)='SIZE' then Size;
    if stopped and (copy(s,1,4)='CONT') then Run;
    if Copy(s,1,4)='PROG'
       then begin
            if length(s)>4
               then begin
                    Close(txt);
                    Reset(txt);
                    Repeat
                      Readln(txt,t);
                      if t='EOF'
                         then begin
                              Writeln(s,' not found!');
                              Close(txt);
                              Reset(txt);
                              Readln(txt);
                              Goto 1
                         end;
                    until (t=s)
               end else
                   if eof(txt) then begin
                      Writeln('EOF'); Goto 1 end;
               Load;
       end else
       if Copy(s,1,3)='RUN'
          then begin
                 curline := FirstLine;
                 if curline = nil then Goto 1;
                 if Length(s) > 3 then begin
                      Val(Copy(s,4,length(s)-3),num,cod);
                      if cod <> 0 then begin
                                       Writeln('Invalid line number');
                                       Goto 1
                                  end;
                      While CurLine^.Number <> num do Begin
                            CurLine := CurLine^.NextLine;
                            if CurLine = nil then begin
                               Writeln('Line not found');
                               Goto 1
                            end;
                    end;
               end;
               CurPos:=1;
               Run
          end else begin
                     Incode(s);
                     Operator(s)
                   end;
  until false
  end;

  Procedure Basic.ErrorMsg(i:byte);
  Begin Writeln(#7#13#10'Error ',i);
        continue:=false end;

 Procedure Basic.Err1;
 Begin
    if (proglength+((lastvar-25) shl 3)) > BasicMem then
       ErrorMsg(1);
 end;

  Procedure Basic.Load;
  var i,cod:integer;
      s:string;
      predline:baslineptr;
  Begin
  curline:=firstline;
  While curline<>nil do begin
          Dispose(curline);
          curline:=curline^.nextline
        end;
  Mode('4');
  lastvar:=25;
  firstline:=nil;
  curline:=nil;
  fsp:=0;
  ssp:=0;
  Repeat
    Readln(txt,s);
    if (Copy(s,1,3)='EOF') or (Copy(s,1,4)='PROG') then begin
       if curline<>nil then curline^.nextline:=nil;
       Err1;
       Size;
       Exit end;
    Writeln(s);
    i:=0;
    While s[i+1] in ['0'..'9'] do Inc(i);
    if i=0 then begin
           Incode(s);
           Operator(s)
           end else begin
               New(curline);
               if firstline=nil then firstline:=curline
                  else predline^.nextline:=curline;
               Val(Copy(s,1,i),curline^.number,cod);
               s:=Copy(s,i+1,length(s)-i);
               Incode(s);
               curline^.line:=s;
               predline:=curline
               end
   until false
  end;

  Procedure Basic.Incode;
  var ic:string;
      si:char;
      found:boolean;
      i,j:integer;
  begin
      ic:='';
      comment:=false;
      i:=0;
      Repeat
      inc(i);
      si:=s[i];
      if si='"' then comment:=not comment;
      if comment
         then ic:=ic+si
         else if si<>#32
              then Begin
                     j:=lcod-1;
                     found:=false;
                     Repeat
                        inc(j);
                        found:=((length(s)-i+2) > Length(lex[j]))
                        and (Copy(s,i,length(lex[j]))=lex[j])
                     until found or (j>=hcod);
                     if found
                        then begin
                               ic:=ic+Chr(j);
                               inc(i,length(lex[j])-1)
                             end
                        else ic:=ic+si;
                   end;
      until i>=length(s);
      s:=ic;
  end;

  Procedure Basic.Size;
  var proglen:word;
  Begin
    proglen:=proglength;
    WriteLN('Program: ',proglen,' VAR: ',lastvar+1,' Total steps: ',
           proglen+((lastvar-25) shl 3) );
  end;

  Function Basic.ProgLength;
  Var count,j:integer;
      li:baslineptr;
  Begin
    li:=firstline;
    count:=0;
    While li<>nil do with li^ do begin
      Inc(count,Length(line)+3);
      li:=li^.nextline
    end;
    proglength:=count
  end;

  Procedure Basic.SearchFor;
  Begin
    With CurLine^
         do begin
              While (    (not ( CurPos>=Length(line) ) )
                     and (not ( line[CurPos] in stp  ) ) )
                     or comment
                     do begin
                          Inc(CurPos);
                          if line[curpos]='"'
                             then comment:=not comment;
                        end;
             if ( CurPos=Length(line) )
                and comment
                then ErrorMsg(2);
         end;
  end;

  Procedure Basic.Run;
  var starpos:integer;
      s:string;
      stp:soc;
  begin
    stopped:=false;
    continue:=true;
    Comment:=false;
    Repeat
      Starpos:=CurPos;
      With curline^
           do begin
              case Byte(line[StarPos]) of
              150: Stp:=[';',#151];
              else STp:=[':'];
           end;
      SearchFor(stp);
      if CurPos=Length(line)
         then begin
                s:=Copy(line,StarPos,CurPos-StarPos+1);
                CurLine:=NexTline;
                CurPos:=1;
              end
         else begin
                s:=Copy(line,StarPos,CurPos-StarPos);
                if line[CurPos] <> #151 then Inc(CurPos)
              end;
      end;
      Operator(s);
      if KeyPressed and (Readkey=#27)
         then begin STOP;
                    Writeln('Stopped via keyboard')
              end;
    until (not continue) or stopped or (Curline=nil)
  end;

  Procedure Basic.Operator;
  var i:integer;
  begin
    case s[1] of
'$', 'A'..'Z': LET(s);
         #149,
         #151: BGOTO( Copy( s, 2, length(s)-1 ) );
         #144: GOSUB( Copy( s, 2, length(s)-1 ) );
         #145: FORTO( Copy( s, 2, length(s)-1 ) );
         #148: NEXT(  Copy( s, 2, length(s)-1 ) );
         #150: BIF(   Copy( s, 2, length(s)-1 ) );
         #152: PRINT( Copy( s, 2, length(s)-1 ) );
         #156: DEFM(  Copy( s, 2, length(s)-1 ) );
         #157: INPUT( Copy( s, 2, length(s)-1 ) );
         #158: MODE(  Copy( s, 2, length(s)-1 ) );
         #153: RETURN;
         #154: STOP;
         #155: BEND;
         #159: VAC;
else ErrorMsg(2);
      end;
  end;

  Function Basic.Expression;
  type memberptr=^member;
       member=record
             value:double;
             operation:char;
             branch:memberptr
       end;

  var i,cod:integer;
      se:string;
      po:byte;
      frstmember,curmember,oldmember:memberptr;


  Function SubExpr(s:string;i:integer):string;
  var level,j:integer;
  Begin
  level:=0;
  j:=i;
  While ( level<>0 )
     or ( not ( s[j] in opset) )
     or ( (s[j] in ['-','+'])
           and ( ( j=i )
                 or (s[j-1] in opset+[#128..#141] ) ) )
  do begin
       if s[j]='('
          then Inc(level)
          else if s[j]=')' then Dec(level);
       if (level<0) or (j=length(s))
          then ErrorMsg(10);
       Inc(j);
  end;
  Subexpr:=Copy(s,i,j-i);
  end;

  BEGIN
  s:=s+#0;
  frstmember:=nil;
  i:=0;
  Repeat
    Inc(i);
    New(curmember);
    if frstmember=nil
       then frstmember:=curmember
       else oldmember^.branch:=curmember;
    with curmember^ do begin
      se:=Subexpr(s,i);
      Inc(i,length(se));
      Case se[1] of
      '(': value:=Expression( Copy(se,2,length(se)-2));
      'p': Value:=Pi;
      '-': Value:=-Expression( Copy(se,2,length(se)-1) );
      '+': Value:=Expression( Copy(se,2,length(se)-1) );
 'A'..'Z': Value:=vrb[Address(se)];
 '.',
 '0'..'9': Begin
                  if se[1]='.'
                     then se:=Concat('0',se);
                  po:=pos('_',se);
                  if po > 0
                     then begin
                           Delete(se,po,1);
                           Insert('e-',se,po);
                          end;
                  Val(se,value,cod);
                  if cod<>0 then ErrorMsg(13);
            end;
#128: Value:=Sin(transcoef*Expression( Copy(se,2,length(se)-1)));
#129: Value:=Cos(transcoef*Expression( Copy(se,2,length(se)-1)));
#130: Value:=TAN(transcoef*Expression( Copy(se,2,length(se)-1)));
#131: Value:=ASN(Expression( Copy(se,2,length(se)-1)))/transcoef;
#132: Value:=ACS(Expression( Copy(se,2,length(se)-1)))/transcoef;
#133: Value:=Arctan(Expression( Copy(se,2,length(se)-1)))/transcoef;
#134: Value:=LOG(Expression( Copy(se,2,length(se)-1)));
#135: Value:=Ln (Expression( Copy(se,2,length(se)-1)));
#136: Value:=Exp(Expression( Copy(se,2,length(se)-1)));
#137: Value:=bSQR(Expression( Copy(se,2,length(se)-1)));
#138: Value:=Abs(Expression( Copy(se,2,length(se)-1)));
#139: Value:=SGN(Expression( Copy(se,2,length(se)-1)));
#140: Value:=bINT(Expression( Copy(se,2,length(se)-1)));
#141: Value:=bFRAC(Expression( Copy(se,2,length(se)-1)));
else ErrorMsg(2);
      end;
      operation:=s[i];
    end;
    oldmember:=curmember;
  until s[i]=#0;

      curmember:=frstmember;
      While curmember^.operation<>#0
         do if curmember^.operation <> '^'
               then curmember:=curmember^.branch
               else With curmember^
                      do begin
                      value:=Power(value,branch^.value);
                      operation:=branch^.operation;
                      Dispose(branch);
                      branch:=branch^.branch;
                    end;  {with}

      curmember:=frstmember;
      While curmember^.operation<>#0
         do if not ( curmember^.operation in ['*','/'] )
               then curmember:=curmember^.branch
               else With curmember^
                      do begin
                          Case operation of
                    '*': value:=value * branch^.value;
                    '/': value:=Divide(value,branch^.value);
                          end; {case}
                      operation:=branch^.operation;
                      Dispose(branch);
                      branch:=branch^.branch;
                    end;  {with}

      curmember:=frstmember;
      While curmember^.operation<>#0
         do if not ( curmember^.operation in ['+','-'] )
               then curmember:=curmember^.branch
               else With curmember^
                      do begin
                          Case operation of
                    '+': value:=value + branch^.value;
                    '-': value:=value - branch^.value;
                          end; {case}
                      operation:=branch^.operation;
                      Dispose(branch);
                      branch:=branch^.branch;
                    end;  {with}

 with frstmember^ do
       if operation=#0 then Expression:=value
                       else ErrorMsg(11);
 Dispose(frstmember);
end;

  Function Basic.Address;
  var ad:word;
      ind:double;
  begin
    ad:=Byte(s[1])-65;
    if length(s)>1
       then begin
       ind:=Expression( Copy(s, 3, length(s)-3));
       if ind<0 then Dec(ad,Trunc(-ind+1e-12))
                else Inc(ad,Trunc(ind+1e-12))
       end;
    if ad>Lastvar then Writeln(#7'Out of data array!');
    address:=ad;
  end;

  Procedure Basic.LET;
  var i:integer;
  Begin
    i:=1;
    Repeat
    Inc(i);
    if i>=Length(s) then begin ErrorMsg(2); Exit end;
    until s[i] = '=';
    if s[1]='$'
       then if Copy(s,i+1,length(s)-i)='$+KEY'
               then ss:=ss+KEY
               else if s[i+1]=#143
                       then ss:=Chr( Trunc( Expression(
                              Copy( s,i+2,length(s)-i-1 ) )+1e-12 ) )
                       else if s[i+1]='"'
                               then ss:=Copy( s,i+2,length(s)-i-2)
                               else ErrorMsg(2)
       else vrb[ Address( Copy(s,1,i-1) ) ]
               := Expression( Copy(s,i+1,length(s)-i) )
  end;

  Procedure Basic.BIF(s:string);
  Var
  i:integer;
  resume, nearequal:boolean;
  scomp:string[32];
  lexpr,rexpr:double;
  Begin
    if s[1]='$'
       then begin
            if s[3]='"'
               then scomp:=Copy(s,4,length(s)-4)
               else if s[3]=#143
                       then scomp:=Chr( Trunc( Expression(
                                Copy( s,4,length(s)-3 ) ) ) )
                       else ErrorMsg(2);
            case s[2] of
            '=': resume := ss = scomp;
            '\': resume := ss <> scomp;
            else ErrorMsg(2) end;
            end
       else begin
              i:=1;
              Repeat
                inc(i);
                if i=length(s) then begin ErrorMsg(2); Exit end;
              until s[i] in ['=', '\', '<', '>', '{', '}'];
              lexpr:=Expression( Copy( s, 1, i-1 ) );
              rexpr:=Expression( Copy( s, i+1, length(s)-i ) );
              NearEqual:=EQ(lexpr,rexpr);
              case s[i] of
              '=': resume := NearEqual;
              '\': resume := not NearEqual;
              '<': resume := (lexpr < rexpr) and not NearEqual;
              '>': resume := (lexpr > rexpr) and not NearEqual;
              '{': resume := (lexpr < rexpr) or NearEqual;
              '}': resume := (lexpr > rexpr) or NearEqual;
              else ErrorMsg(2) end;
            end;
            if not resume then begin
                                 curline:=curline^.nextline;
                                 curpos:=1;
                               end;
  end;

  Procedure Basic.BGOTO;
  Var m:word;
  Begin
    m:=trunc( Expression( s ));
    curline:=firstline;
    while curline^.number<>m do
        if curline=nil
           then begin ErrorMsg(5);Exit end
           else curline:=curline^.nextline;
    curpos:=1
  end;

  Procedure Basic.GOSUB;
  Begin
    if ssp<8
       then begin
               Inc(ssp);
               with SUBstack[ssp] do begin
                    line:=curline;
                    index:=curpos end;
               BGOTO(s);
            end
       else errormsg(6);
    end;

  Procedure Basic.RETURN;
  Begin
    if ssp=0
       then ErrorMsg(6)
       else with SUBstack[ssp] do begin
                 curline:=line;
                 curpos:=index;
                 Dec(ssp);
                 end;
  end;

  Procedure Basic.FORTO;
  var i,j:integer;
      ad:word;
      last,step:double;
  Begin
  i:=1;
  Repeat
    Inc(i);
    if i>=length(s) then begin ErrorMsg(2); Exit end;
  until s[i]='=';
  ad:=Address( Copy (s,1,i-1 ) );
  Repeat
    inc(i);
    if i>=length(s) then begin ErrorMsg(2); Exit end;
    until s[i]=#146;
  LET( Copy( s, 1, i-1 ) );
  j:=i+1;
  Repeat
  inc(j);
  until (j>length(s)) or (s[j]=#147);
  last:=Expression( Copy( s, i+1, j-i-1 ) );
  if j>length(s)
     then step:=1
     else step:=Expression( Copy( s, j+1, length(s)-j ) );

  i:=1;
    While (ad <> FORstack[i].adres)
      and (i <= fsp) do Inc(i);
    if i>4 then ErrorMsg(6)
           else begin
                  if i>fsp
                     then begin
                             fsp:=i;
                             forstack[fsp].adres:=ad
                          end;
                  With forstack[fsp] do
                     begin
                       stopval:=last;
                       stepval:=step;
                       line:=curline;
                       index:=curpos;
                     end;
                end;
           end;

  Procedure Basic.NEXT;
  Var
  i:integer;
  ad:word;
  Begin
  Ad:=Address(s);
  i:=0;
  Repeat
  Inc(i);
  if i>fsp then begin ErrorMsg(7); exit end;
  until forstack[i].adres=ad;
  With forstack[i] do begin
       vrb[adres]:=vrb[adres]+stepval;
       if ( ( ( vrb[adres] < stopval ) or Eq(vrb[adres],stopval ) )
                                              and ( stepval > 0 ) )
       or ( ( ( vrb[adres] > stopval ) or Eq(vrb[adres],stopval ) )
                                              and ( stepval < 0 ) )
          then begin
                 curline:=line;
                 curpos:=index;
               end
          else Dec(fsp);
  end;
  end;

  Procedure Basic.PRINT(s:string);
  var i,j:integer;
      dl:string;
  Begin
  i:=0;
  Repeat
    j:=i;
    Repeat
      inc(j);
      if s[j]='"' then comment:=not comment;
    until ( not comment )
            and ( ( j>length(s) )
                  or ( s[j]=',' )
                  or ( s[j]=';' ) );
    if ( s[i+1]='"' ) and ( s[j-1]='"')
       then Write(Copy(s, i+2, j-i-3))
       else if s[i+1]='$'
               then Write(ss)
               else if s[i+1]=#143
                       then Write( Chr( Trunc( Expression(
                             Copy(s, i+2, j-i-2 ) ) ) ) )
                       else Write( Expression(
                             Copy(s, i+1, j-i-1 ) ):12:12 );
    if ( j<=length(s) ) and ( s[j] = ';')
       then Write(' ')
       else begin Readln(dl);
                  if length(dl)>0 then begin
                             Incode(dl); Operator(dl) end;
            end;
        i:=j;
  until j>=length(s);
  end;

  Procedure Basic.INPUT(s:string);
  var i,j,cod:integer;
      inp:string;
  Begin
  i:=0;
  Repeat
    j:=i;
    Repeat
      inc(j);
      if (j<=length(s)) and (s[j]='"') then comment:=not comment;
    until ( not comment ) and ( ( j>length(s) ) or ( s[j]=',' ) );
    if ( s[i+1]='"' ) and ( s[j-1]='"')
       then Write(Copy(s, i+2, j-i-3))
       else Repeat
            cod:=0;
            Write('?');
            Readln(inp);
            if inp='END' then Begin bEND; Exit end;
            if inp='STOP' then begin STOP; Exit end;
            if s[i+1]='$'
              then ss:=INP
              else begin
                   vrb[ Address( Copy(s, i+1, j-i-1) )]
                       :=Expression( inp );
                    if cod<>0 then Writeln(#7'Error 2');
                   end;
            until cod=0;
    i:=j;
  until j>length(s);
  end;

  Procedure Basic.STOP;
  Begin
    stopped := true
  end;

  Procedure Basic.BEND;
  Begin
  continue := false
  end;

  Procedure Basic.DEFM;
  Var n:integer;
  Begin
    n:=Trunc( Expression( s )+1e-13 );
    if n>=0 then LastVar := 25 + n
            else Write(#7);
    Err1;
  end;

  Procedure Basic.MODE;
  Var m:integer;
  Begin m := Trunc( Expression( s )+1e-13 );
      case m of
        4: transcoef := pi/180;
        5: transcoef := 1;
        6: transcoef := pi/100;
        else ErrorMsg(3)
  end end;

  Procedure Basic.VAC;
  var i:integer; Begin SS:='';
   for i:=0 to lastvar do vrb[i]:=0 end;

  Function Basic.TAN; Var c:double; Begin c:=cos(x);
             if c=0 then ErrorMsg(3) else tan:=Sin(x)/C end;

  Function Basic.ASN; Var sum,old,xpow:double; n:integer;
    Begin if abs(x)>1 then ErrorMsg(3) else begin xpow:=x; sum:=X; n:=0;
          Repeat old:=sum; Inc(n,2); xpow:=xpow*(n-1)/n*x*x;
    sum:=sum+xpow/(n+1) until sum=old; asn:=sum end end;

  Function Basic.ACS; Begin acs:=(pi/2-asn(x)) end;

  Function Basic.LOG; Begin log:=ln(x)/ln(10) end;

  Function Basic.bSQR; Begin if x<0
                                then ErrorMsg(3)
                                else bSqr:=Sqrt(x) end;


  Function Basic.SGN; Begin if EQ(x,0) then sgn:=0 else
               if x< 0 then sgn:=-1 else sgn:=1 end;

  Function Basic.bINT; Begin if x>0 then bInt:=Int(x+1e-13)
                                    else bInt:=Int(x-1e-13)
                                 end;

  Function Basic.bFRAC; Begin if EQ(x,BInt(x)) then bFrac:=0
                                 else if x<0 then bfrac:=frac(x-1e-13)
                                             else bfrac:=Frac(x+1e-13) end;

  Function Basic.Power; Var i:integer; r:double;
    Begin if x=0 then power:=0;
    if x<0 then if bFrac(y) <> 0
           then ErrorMsg(3)
                      else begin r:=1;
                      for i:=1 to Round(abs(y)) do r:=r*x;
                      if y<0 then r:=1/r; power:=r end;
    if x>0 then begin power:=Exp(y*Ln(x)) end;
    end;

  Function Basic.Divide;
    Begin if y=0 then ErrorMsg(3)
          else divide:=x/y end;

  Function Basic.KEY;
    Begin
      if KeyPressed then key:=Readkey else key:=''
    end;

  Function Basic.EQ(x,y:double):boolean;
  Begin Eq:= ( ( x = y ) or ( Abs(x-y) < Abs(x+y)*1e-12 ) ) end;

Procedure ReadTable;
var i:integer;
    code:byte;
    c:char;
begin
  Assign(table,'lexem.tab');Reset(table);
  for i:=lcod to hcod do
      Readln(table,code,c,lex[i]);
      Close(table)
end;

Begin
  ReadTable;
end.